unit u_c_no_ioc;
  interface
  implementation
    type IDependency=
             interface
               ['{618030A2-DB17-4532-81D0-D5AA6F73DC66}']
               procedure GetType;
             end; // IDependency
         TDependencyA=
             class(TInterfacedObject, IDependency)
               public
                 procedure GetType;
             end; // TDependencyA
         TDependencyB=
             class(TInterfacedObject, IDependency)
               public
                 procedure GetType;
             end; // TDependencyB
         TConsumer=
             class
               private
                 FDependency: IDependency;
               public
                 constructor Create(aDependencyClassName: string);
                 procedure GetDependencyType;
             end; 
         { TDependencyA }

    procedure TDependencyA.GetType;
      begin
        WriteLn('Instance of type TDependencyA');
      end;
    { TDependencyB }
    procedure TDependencyB.GetType;
      begin
        WriteLn('Instance of type TDependencyB');
      end;
    { TConsumer }
    constructor TConsumer.Create(aDependencyClassName: string);
      begin
        if aDependencyClassName= 'TDependencyA'
          then FDependency:= TDependencyA.Create
          else
            if aDependencyClassName= 'TDependencyB'
              then FDependency:= TDependencyB.Create;
      end; // Create   

    procedure TConsumer.GetDependencyType;
      begin
        if FDependency<> nil
          then FDependency.GetType;
      end; // GetDependencyType   

    end.
