// u_c_person
// 2013-02-09

// -- (C) John COLIBRI 2013
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_using_ioc;
  interface
    type i_dependency=
             interface
               ['{618030A2-DB17-4532-81D0-D5AA6F73DC66}']
               procedure compute;
             end; // i_dependency

         c_consumer=
             class
               private
                 m_i_dependency: i_dependency;
               public
                 constructor create_consumer(p_i_dependency: i_dependency);
                 procedure do_compute;
             end; // c_consumer

         c_dependency_injector=
             class
               public
                 class function f_i_dependency(p_qualified_dependency_class_name: string):
                       i_dependency;
             end; // c_dependency_injector

  implementation
    uses RTTI, u_display_simple, u_display_rtti
      ;

    // --  c_consumer

    constructor c_consumer.create_consumer(p_i_dependency: i_dependency);
      begin
        m_i_dependency:= p_i_dependency;
      end; // create_consumer

    procedure c_consumer.do_compute;
      begin
        if m_i_dependency<> nil
          then m_i_dependency.compute;
      end; // do_compute

    // -- c_dependency_injector

    class function c_dependency_injector.f_i_dependency(p_qualified_dependency_class_name: string):
          i_dependency;
      var l_rtti_context: TRttiContext;
          l_c_rtti_instance_type: TRttiInstanceType;
          l_c_rtti_type: tRttiType;
          l_c_class_ref: tClass;
          l_i_dependency: i_dependency;
      begin
(*
        display('find '+ p_qualified_dependency_class_name);
        l_c_rtti_type:= l_rtti_context.FindType(p_qualified_dependency_class_name);
        if l_c_rtti_type= Nil
            then begin
                display('nil');
                Exit;
              end;

        display(f_display_type_kind(l_c_rtti_type.TypeKind));
*)
        l_c_rtti_instance_type:= l_rtti_context.FindType(p_qualified_dependency_class_name)
            as TRttiInstanceType;

        if l_c_rtti_instance_type<> nil
          then begin
              l_c_class_ref:= l_c_rtti_instance_type.MetaclassType;
              display(l_c_class_ref.ClassName);
              Result:= l_c_rtti_instance_type.GetMethod('create')
                  .Invoke(l_c_class_ref, []).AsInterface as i_dependency
(*
              Result:= l_c_rtti_instance_type.GetMethod('create_consumer').Invoke(l_c_rtti_instance_type.
                  MetaclassType, []).AsInterface as i_dependency
*)
            end
          else display('l_c_rtti_instance_type NIL');
      end; // f_i_dependency

    end.
